diff -uNr mythtv-0.21/libs/libmyth/mythcontext.cpp mythtv/libs/libmyth/mythcontext.cpp
--- mythtv-0.21/libs/libmyth/mythcontext.cpp	2008-03-07 01:50:20.000000000 +0100
+++ mythtv/libs/libmyth/mythcontext.cpp	2009-02-09 09:59:19.000000000 +0100
@@ -87,7 +87,7 @@
     else
     {
         QStringList verboseOpts = QStringList::split(',', arg);
-        for (QStringList::Iterator it = verboseOpts.begin(); 
+        for (QStringList::Iterator it = verboseOpts.begin();
              it != verboseOpts.end(); ++it )
         {
             option = *it;
@@ -198,7 +198,7 @@
 
     void LoadLogSettings(void);
     void LoadDatabaseSettings(void);
-    
+
     bool LoadSettingsFile(void);
     bool WriteSettingsFile(const DatabaseParams &params,
                            bool overwrite = false);
@@ -224,9 +224,9 @@
     Settings *m_settings;          ///< connection stuff, theme, button style
     Settings *m_qtThemeSettings;   ///< everything else theme-related
 
-    QString   m_installprefix;     ///< Compile-time PREFIX, or generated
+    QString   m_installprefix;     ///< Compile-time RUNPREFIX, or generated
                                    ///< from enviroment ($MYTHTVDIR or $cwd)
-    QString   m_installlibdir;     ///< Compile-time LIBDIR, or generated
+    QString   m_libname;           ///< Compile-time LIBDIRNAME
 
     bool      m_gui;               ///< Should this context use GUI elements?
     bool      m_backend;           ///< Is this host any sort of backend?
@@ -246,7 +246,7 @@
     // Dimensions of the theme
     int m_baseWidth, m_baseHeight;
 
-    
+
     QMutex  m_hostnamelock;      ///< Locking for thread-safe copying of:
     QString m_localhostname;     ///< hostname from mysql.txt or gethostname()
 
@@ -261,7 +261,7 @@
     bool attemptingToConnect;
 
     MDBManager m_dbmanager;
-    
+
     QMap<QString, QImage> imageCache;
 
     QString language;
@@ -314,7 +314,7 @@
 MythContextPrivate::MythContextPrivate(MythContext *lparent)
     : parent(lparent),
       m_settings(new Settings()), m_qtThemeSettings(new Settings()),
-      m_installprefix(PREFIX), m_installlibdir(LIBDIR),
+      m_installprefix(RUNPREFIX), m_libname(LIBDIRNAME),
       m_gui(false), m_backend(false), m_themeloaded(false),
       m_menuthemepathname(QString::null), m_themepathname(QString::null),
       m_backgroundimage(NULL),
@@ -356,21 +356,15 @@
         // If the PREFIX is relative, evaluate it relative to our
         // executable directory. This can be fragile on Unix, so
         // use relative PREFIX values with care.
+
+        VERBOSE(VB_IMPORTANT,
+                "Relative PREFIX! (" + m_installprefix +
+                ")\n\t\tappDir=" + prefixDir.canonicalPath());
         prefixDir.cd(m_installprefix);
         m_installprefix = prefixDir.canonicalPath();
     }
-    else if (prefixDir.path().contains(".app/Contents/MacOS"))
-    {
-        prefixDir.cd("../Resources");
-        if (QDir(prefixDir.canonicalPath() + "/bin").exists() ||
-            QDir(prefixDir.canonicalPath() + "/share").exists())
-            m_installprefix = prefixDir.canonicalPath();
-        if (QDir(prefixDir.canonicalPath() + "/lib").exists())
-            m_installlibdir = prefixDir.canonicalPath() + "/lib";
-    }
 
-    VERBOSE(VB_IMPORTANT, QString("Using runtime prefix = %1, libdir = %2")
-                          .arg(m_installprefix).arg(m_installlibdir));
+    VERBOSE(VB_IMPORTANT, "Using runtime prefix = " + m_installprefix);
 }
 
 MythContextPrivate::~MythContextPrivate()
@@ -463,19 +457,33 @@
     }
 
     QDesktopWidget * desktop = QApplication::desktop();
+    bool             hasXinerama = GetNumberOfXineramaScreens() > 1;
+    int              numScreens  = desktop->numScreens();
+    int              screen;
 
-    VERBOSE(VB_IMPORTANT,
-            QString("Total desktop dim: %1x%2, with %3 screen[s].")
-            .arg(desktop->width()).arg(desktop->height())
-            .arg(desktop->numScreens()));
+    if (hasXinerama)
+        VERBOSE(VB_GENERAL,
+                QString("Total desktop dim: %1x%2, over %3 screen[s].")
+                .arg(desktop->width()).arg(desktop->height()).arg(numScreens));
+    if (numScreens > 1)
+        for (screen = 0; screen < numScreens; ++screen)
+        {
+            QRect dim = desktop->screenGeometry(screen);
+            VERBOSE(VB_GENERAL,
+                    QString("Screen %1 dim: %2x%3.")
+                    .arg(screen).arg(dim.width()).arg(dim.height()));
+        }
+
+    screen = desktop->primaryScreen();
+    VERBOSE(VB_GENERAL, QString("Primary screen %1.").arg(screen));
 
-    int screen = parent->GetNumSetting("XineramaScreen",
-                                       desktop->primaryScreen());
+    if (hasXinerama)
+        screen = parent->GetNumSetting("XineramaScreen", screen);
 
     if (screen == -1)       // Special case - span all screens
     {
-        VERBOSE(VB_GENERAL, QString("Using all screens (currently %1)")
-                            .arg(desktop->numScreens()));
+        VERBOSE(VB_GENERAL, QString("Using all %1 screens.")
+                                     .arg(numScreens));
         m_xbase  = 0;
         m_ybase  = 0;
         m_width  = desktop->width();
@@ -483,19 +491,23 @@
 
         VERBOSE(VB_GENERAL, QString("Total width = %1, height = %2")
                             .arg(m_width).arg(m_height));
+        return;
     }
-    else                    // User specified a single screen
+
+    if (hasXinerama)        // User specified a single screen
     {
-        if (screen < 0 || screen >= desktop->numScreens())
+        if (screen < 0 || screen >= numScreens)
         {
             VERBOSE(VB_IMPORTANT, QString(
                         "Xinerama screen %1 was specified,"
                         " but only %2 available, so using screen 0.")
-                    .arg(screen).arg(desktop->numScreens()));
+                    .arg(screen).arg(numScreens));
             screen = 0;
         }
+    }
 
 
+    {
         QRect bounds;
 
         bool inWindow = parent->GetNumSetting("RunFrontendInWindow", 0);
@@ -528,7 +540,9 @@
     if (UPnPclient)
     {
         m_UPnP = UPnPclient;
+#ifndef _WIN32
         m_XML  = (XmlConfiguration *)UPnp::g_pConfig;
+#endif
     }
 
     // Creates screen saver control if we will have a GUI
@@ -616,7 +630,7 @@
             manualSelect = !noPrompt;     // If allowed, prompt user
     }
 
-    if (!m_gui) 
+    if (!m_gui)
         manualSelect = false;  // no interactive command-line chooser yet
 
 
@@ -624,19 +638,19 @@
     // Last, get the user to select a backend from a possible list:
     if (manualSelect)
     {
-        switch (ChooseBackend(QString::null)) 
-        { 
-            case -1:    // User asked to configure database manually 
+        switch (ChooseBackend(QString::null))
+        {
+            case -1:    // User asked to configure database manually
                 if (PromptForDatabaseParams(""))
                     break;
                 else
                     goto NoDBfound;   // User cancelled - changed their mind?
-    
-            case 0:   // User cancelled. Exit application 
+
+            case 0:   // User cancelled. Exit application
                 goto NoDBfound;
 
-            case 1:    // User selected a backend, so m_DBparams 
-                break; // should now contain the database details 
+            case 1:    // User selected a backend, so m_DBparams
+                break; // should now contain the database details
 
             default:
                 goto NoDBfound;
@@ -645,12 +659,12 @@
     }
 
 
-    // Queries the user for the DB info, using the command 
+    // Queries the user for the DB info, using the command
     // line or the GUI depending on the application.
     while (failure.length())
     {
         VERBOSE(VB_IMPORTANT, QString("%1").arg(failure));
-        if (( manualSelect && ChooseBackend(failure)) || 
+        if (( manualSelect && ChooseBackend(failure)) ||
             (!manualSelect && PromptForDatabaseParams(failure)))
         {
             failure = TestDBconnection();
@@ -734,7 +748,7 @@
     font.setPointSize((int)floor(14 * m_hmult));
 
     QApplication::setFont(font);
-    
+
     //VERBOSE(VB_IMPORTANT, QString("GUI multipliers are: width %1, height %2").arg(m_wmult).arg(m_hmult));
 }
 
@@ -746,7 +760,7 @@
     m_logprintlevel = parent->GetNumSetting("LogPrintLevel", LP_ERROR);
 }
 
-/**     
+/**
  * Load database and host settings from mysql.txt, or set some defaults
  *
  * \returns true if mysql.txt was parsed
@@ -830,7 +844,7 @@
 {
     QString path = MythContext::GetConfDir() + "/mysql.txt";
     QFile   * f  = new QFile(path);
-    
+
     if (!overwrite && f->exists())
     {
         return false;
@@ -854,7 +868,7 @@
                                       "for writing").arg(path));
         return false;
     }
-    
+
     VERBOSE(VB_IMPORTANT, QString("Writing settings file %1").arg(path));
     QTextStream s(f);
     s << "DBHostName=" << params.dbHostName << endl;
@@ -883,12 +897,12 @@
       << "# will need to reconfigure mythtv (or futz with the DB) every time.\n"
       << "# TWO HOSTS MUST NOT USE THE SAME VALUE\n"
       << "#\n";
-    
+
     if (params.localEnabled)
         s << "LocalHostName=" << params.localHostName << endl;
     else
         s << "#LocalHostName=my-unique-identifier-goes-here\n";
-    
+
     s << endl
       << "# If you want your frontend to be able to wake your MySQL server\n"
       << "# using WakeOnLan, have a look at the following settings:\n"
@@ -902,28 +916,28 @@
         s << "WOLsqlReconnectWaitTime=" << params.wolReconnect << endl;
     else
         s << "#WOLsqlReconnectWaitTime=0\n";
-    
+
     s << "#\n"
       << "#\n"
       << "# This is the number of retries to wake the MySQL server\n"
       << "# until the frontend gives up\n"
       << "#\n";
-     
+
     if (params.wolEnabled)
         s << "WOLsqlConnectRetry=" << params.wolRetry << endl;
     else
         s << "#WOLsqlConnectRetry=5\n";
-    
+
     s << "#\n"
       << "#\n"
       << "# This is the command executed to wake your MySQL server.\n"
       << "#\n";
-    
+
     if (params.wolEnabled)
         s << "WOLsqlCommand=" << params.wolCommand << endl;
     else
         s << "#WOLsqlCommand=echo 'WOLsqlServerCommand not set'\n";
-    
+
     f->close();
     return true;
 }
@@ -931,7 +945,7 @@
 bool MythContextPrivate::FindSettingsProbs(void)
 {
     bool problems = false;
-    
+
     if (m_DBparams.dbHostName.isEmpty())
     {
         problems = true;
@@ -1012,7 +1026,7 @@
         // Tell the user what went wrong:
         if (error.length())
             MythPopupBox::showOkPopup(mainWindow, "DB connect failure", error);
-        
+
         // ask user for database parameters
         DatabaseSettings settings(m_DBhostCp);
         accepted = (settings.exec() == QDialog::Accepted);
@@ -1025,7 +1039,7 @@
     {
         DatabaseParams params = parent->GetDatabaseParams();
         QString response;
-        
+
         // give user chance to skip config
         cout << endl << error << endl << endl;
         response = getResponse("Would you like to configure the database "
@@ -1033,7 +1047,7 @@
                                "yes");
         if (!response || response.left(1).lower() != "y")
             return false;
-        
+
         params.dbHostName = getResponse("Database host name:",
                                         params.dbHostName);
         response = getResponse("Should I test connectivity to this host "
@@ -1048,13 +1062,13 @@
                                         params.dbUserName);
         params.dbPassword = getResponse("Database password:",
                                         params.dbPassword);
-        
+
         params.localHostName = getResponse("Unique identifier for this machine "
                                            "(if empty, the local host name "
                                            "will be used):",
                                            params.localHostName);
         params.localEnabled = !params.localHostName.isEmpty();
-        
+
         response = getResponse("Would you like to use Wake-On-LAN to retry "
                                "database connections?",
                                (params.wolEnabled ? "yes" : "no"));
@@ -1071,7 +1085,7 @@
             params.wolCommand   = getResponse("Command to use to wake server:",
                                               params.wolCommand);
         }
-        
+
         accepted = parent->SaveDatabaseParams(params);
     }
     return accepted;
@@ -1236,17 +1250,17 @@
  * Search for backends via UPnP, put up a UI for the user to choose one
  */
 int MythContextPrivate::ChooseBackend(const QString &error)
-{ 
+{
     if (!InitUPnP())
         return -1;
 
-    TempMainWindow(); 
- 
+    TempMainWindow();
+
     // Tell the user what went wrong:
     if (error.length())
         MythPopupBox::showOkPopup(mainWindow, "DB connect failure", error);
 
-    VERBOSE(VB_GENERAL, "Putting up the UPnP backend chooser"); 
+    VERBOSE(VB_GENERAL, "Putting up the UPnP backend chooser");
 
     BackendSelect *BEsel = new BackendSelect(mainWindow, &m_DBparams);
     switch (BEsel->exec())
@@ -1290,10 +1304,10 @@
     }
 
     delete BEsel;
-    EndTempWindow(); 
+    EndTempWindow();
 
-    return 1; 
-} 
+    return 1;
+}
 
 /**
  * Try to store the current location of this backend in config.xml
@@ -1388,17 +1402,17 @@
     // only work for ones that have PIN access disabled (i.e. 0000)
     if (UPnPconnect(BE, QString::null))
         return 1;
-    
+
     return -1;   // Try to force chooser & PIN
 }
 
-/** 
- * Get the default backend from config.xml, use UPnP to find it. 
+/**
+ * Get the default backend from config.xml, use UPnP to find it.
  *
  * Sets a string if there any connection problems
- */ 
+ */
 bool MythContextPrivate::DefaultUPnP(QString &error)
-{ 
+{
     XmlConfiguration *XML = new XmlConfiguration("config.xml");
     QString           loc = "MCP::DefaultUPnP() - ";
     QString localHostName = XML->GetValue(kDefaultBE + "LocalHostName", "");
@@ -1425,7 +1439,7 @@
 
     m_UPnP->PerformSearch(gBackendURI);
     DeviceLocation *pDevLoc = m_UPnP->g_SSDPCache.Find(gBackendURI, USN);
-    if (!pDevLoc) 
+    if (!pDevLoc)
     {
         error = "Cannot find default UPnP backend";
         return false;
@@ -1442,22 +1456,22 @@
 
         return true;
     }
-    
+
     error = "Cannot connect to default backend via UPnP. Wrong saved PIN?";
     return false;
 }
 
-/** 
+/**
  * Query a backend via UPnP for its database connection parameters
- */ 
+ */
 bool MythContextPrivate::UPnPconnect(const DeviceLocation *backend,
                                      const QString        &PIN)
 {
-    QString        error; 
+    QString        error;
     QString        LOC = "UPnPconnect() - ";
     QString        URL = backend->m_sLocation;
     MythXMLClient  XML(URL);
- 
+
     VERBOSE(VB_UPNP, LOC + QString("Trying host at %1").arg(URL));
     switch (XML.GetConnectionInfo(PIN, &m_DBparams, error))
     {
@@ -1466,8 +1480,8 @@
 
         case UPnPResult_ActionNotAuthorized:
             // The stored PIN is probably not correct.
-            // We could prompt for the PIN and try again, but that needs a UI. 
-            // Easier to fail for now, and put up the full UI selector later 
+            // We could prompt for the PIN and try again, but that needs a UI.
+            // Easier to fail for now, and put up the full UI selector later
             VERBOSE(VB_UPNP, LOC + error + ". Wrong PIN?");
             return false;
 
@@ -1524,20 +1538,20 @@
         return false;
     }
 
-#ifdef _WIN32 
-    // HOME environment variable might not be defined 
-    // some libraries will fail without it 
-    char *home = getenv("HOME"); 
-    if (!home) 
-    { 
+#ifdef _WIN32
+    // HOME environment variable might not be defined
+    // some libraries will fail without it
+    char *home = getenv("HOME");
+    if (!home)
+    {
         home = getenv("LOCALAPPDATA");      // Vista
         if (!home)
             home = getenv("APPDATA");       // XP
         if (!home)
             home = ".";  // getenv("TEMP")?
 
-        _putenv(QString("HOME=%1").arg(home)); 
-    } 
+        _putenv(QString("HOME=%1").arg(home));
+    }
 #endif
 
     if (QDir::homeDirPath() == "/" && ! getenv("MYTHCONFDIR"))
@@ -1570,6 +1584,15 @@
 
 bool MythContext::ConnectToMasterServer(bool blockingClient)
 {
+    if (gContext->IsMasterBackend())
+    {
+        // Should never get here unless there is a bug in the code somewhere.
+        // If this happens, it can cause endless event loops.
+        VERBOSE(VB_IMPORTANT, "ERROR: Master backend tried to connect back "
+                "to itself!");
+        return false;
+    }
+
     QString server = gContext->GetSetting("MasterServerIP", "localhost");
     int port = gContext->GetNumSetting("MasterServerPort", 6543);
 
@@ -1610,12 +1633,12 @@
         {
             serverSock->DownRef();
             serverSock = NULL;
-        
+
             if (d->attemptingToConnect)
                 break;
             d->attemptingToConnect = true;
 
-            // only inform the user of a failure if WOL is disabled 
+            // only inform the user of a failure if WOL is disabled
             if (sleepTime <= 0)
             {
                 VERBOSE(
@@ -1631,7 +1654,7 @@
                         manageLock = true;
                         d->serverSockLock.unlock();
                     }
-                    MythPopupBox::showOkPopup(d->mainWindow, 
+                    MythPopupBox::showOkPopup(d->mainWindow,
                                               "connection failure",
                                               tr("Could not connect to the "
                                                  "master backend server -- is "
@@ -1687,14 +1710,14 @@
         serverSock->writeStringList(strlist);
         serverSock->readStringList(strlist, true);
 
-        if (eventSock && eventSock->state() == MythSocket::Idle)    
+        if (eventSock && eventSock->state() == MythSocket::Idle)
         {
             // Assume that since we _just_ connected the one socket, this one
             // will work, too.
             eventSock->connect(hostname, port);
 
             eventSock->Lock();
-            
+
             QString str = QString("ANN Monitor %1 %2")
                                  .arg(d->m_localhostname).arg(true);
             QStringList strlist = str;
@@ -1718,7 +1741,7 @@
 
     if (d->serverSock == NULL)
         return;
-    
+
     strlist << "BLOCK_SHUTDOWN";
     d->serverSock->writeStringList(strlist);
     d->serverSock->readStringList(strlist);
@@ -1730,7 +1753,7 @@
     strlist << "BLOCK_SHUTDOWN";
 
     d->eventSock->Lock();
-    
+
     d->eventSock->writeStringList(strlist);
     d->eventSock->readStringList(strlist);
 
@@ -1740,14 +1763,14 @@
 void MythContext::AllowShutdown(void)
 {
     QStringList strlist;
-    
+
     if (d->serverSock == NULL)
-        return;        
-    
+        return;
+
     strlist << "ALLOW_SHUTDOWN";
     d->serverSock->writeStringList(strlist);
     d->serverSock->readStringList(strlist);
-    
+
     if (d->eventSock == NULL || d->eventSock->state() != MythSocket::Connected)
         return;
 
@@ -1755,7 +1778,7 @@
     strlist << "ALLOW_SHUTDOWN";
 
     d->eventSock->Lock();
-    
+
     d->eventSock->writeStringList(strlist);
     d->eventSock->readStringList(strlist);
 
@@ -1810,7 +1833,7 @@
 
     if (QString(strlist[0]) == "FALSE")
         backendOnLocalhost = false;
-    else 
+    else
         backendOnLocalhost = true;
 
     return !backendOnLocalhost;
@@ -1826,7 +1849,7 @@
         ConnectToMasterServer();
         d->serverSockLock.unlock();
     }
-    
+
     if (d->serverSock)
         ret = QString("myth://%1:%2/")
                      .arg(d->serverSock->peerAddress().toString())
@@ -1884,9 +1907,9 @@
     return GetSetting("RecordFilePrefix");
 }
 
-QString MythContext::GetInstallPrefix(void) 
-{ 
-    return d->m_installprefix; 
+QString MythContext::GetInstallPrefix(void)
+{
+    return d->m_installprefix;
 }
 
 QString MythContext::GetConfDir(void)
@@ -1906,70 +1929,70 @@
     return dir;
 }
 
-QString MythContext::GetShareDir(void) 
-{ 
-    return d->m_installprefix + "/share/mythtv/"; 
+QString MythContext::GetShareDir(void)
+{
+    return d->m_installprefix + "/share/mythtv/";
 }
 
-QString MythContext::GetLibraryDir(void) 
-{ 
-    return d->m_installlibdir + "/mythtv/"; 
+QString MythContext::GetLibraryDir(void)
+{
+    return d->m_installprefix + "/" + d->m_libname + "/mythtv/";
 }
 
-QString MythContext::GetThemesParentDir(void) 
-{ 
-    return GetShareDir() + "themes/"; 
+QString MythContext::GetThemesParentDir(void)
+{
+    return GetShareDir() + "themes/";
 }
 
-QString MythContext::GetPluginsDir(void) 
-{ 
-    return GetLibraryDir() + "plugins/"; 
+QString MythContext::GetPluginsDir(void)
+{
+    return GetLibraryDir() + "plugins/";
 }
 
-QString MythContext::GetPluginsNameFilter(void) 
-{ 
-    return kPluginLibPrefix + "*" + kPluginLibSuffix; 
+QString MythContext::GetPluginsNameFilter(void)
+{
+    return kPluginLibPrefix + "*" + kPluginLibSuffix;
 }
 
-QString MythContext::FindPlugin(const QString &plugname) 
-{ 
-    return GetPluginsDir() + kPluginLibPrefix + plugname + kPluginLibSuffix; 
+QString MythContext::FindPlugin(const QString &plugname)
+{
+    return GetPluginsDir() + kPluginLibPrefix + plugname + kPluginLibSuffix;
 }
 
-QString MythContext::GetTranslationsDir(void) 
-{ 
-    return GetShareDir() + "i18n/"; 
+QString MythContext::GetTranslationsDir(void)
+{
+    return GetShareDir() + "i18n/";
 }
 
-QString MythContext::GetTranslationsNameFilter(void) 
-{ 
-    return "mythfrontend_*.qm"; 
+QString MythContext::GetTranslationsNameFilter(void)
+{
+    return "mythfrontend_*.qm";
 }
 
-QString MythContext::FindTranslation(const QString &translation) 
-{ 
+QString MythContext::FindTranslation(const QString &translation)
+{
     return GetTranslationsDir()
-           + "mythfrontend_" + translation.lower() + ".qm"; 
+           + "mythfrontend_" + translation.lower() + ".qm";
 }
 
-QString MythContext::GetFontsDir(void) 
-{ 
+QString MythContext::GetFontsDir(void)
+{
     return GetShareDir();
 }
 
-QString MythContext::GetFontsNameFilter(void) 
-{ 
-    return "*ttf"; 
+QString MythContext::GetFontsNameFilter(void)
+{
+    return "*ttf";
 }
 
-QString MythContext::FindFont(const QString &fontname) 
-{ 
-    return GetFontsDir() + fontname + ".ttf"; 
+QString MythContext::FindFont(const QString &fontname)
+{
+    return GetFontsDir() + fontname + ".ttf";
 }
 
-QString MythContext::GetFiltersDir(void) 
-{ 
-    return GetLibraryDir() + "filters/"; 
+QString MythContext::GetFiltersDir(void)
+{
+    return GetLibraryDir() + "filters/";
 }
 
 
@@ -2002,7 +2025,7 @@
     if (style != "")
         qApp->setStyle(style);
 
-    QString themename = GetSetting("Theme");    
+    QString themename = GetSetting("Theme");
     QString themedir = FindThemeDir(themename);
 
     ThemeInfo *themeinfo = new ThemeInfo(themedir);
@@ -2022,12 +2045,12 @@
 
     if (themeinfo)
         delete themeinfo;
-    
+
     // Recalculate GUI dimensions
     d->StoreGUIsettings();
-        
+
     d->m_themepathname = themedir + "/";
-    
+
     themedir += "/qtlook.txt";
     d->m_qtThemeSettings->ReadSettings(themedir);
     d->m_themeloaded = false;
@@ -2061,8 +2084,8 @@
 {
     QString cachedirname = MythContext::GetConfDir() + "/themecache/";
 
-    d->themecachedir = cachedirname + GetSetting("Theme") + "." + 
-                       QString::number(d->m_screenwidth) + "." + 
+    d->themecachedir = cachedirname + GetSetting("Theme") + "." +
+                       QString::number(d->m_screenwidth) + "." +
                        QString::number(d->m_screenheight);
 
     QDir dir(cachedirname);
@@ -2158,7 +2181,7 @@
 
     dir.rmdir(dirname);
 }
-    
+
 void MythContext::CacheThemeImages(void)
 {
     if (d->m_screenwidth == d->m_baseWidth &&
@@ -2175,7 +2198,7 @@
                                             const QString &subdirname)
 {
     QDir dir(dirname);
-    
+
     if (!dir.exists())
         return;
 
@@ -2220,7 +2243,7 @@
         else if (fi->isDir())
             continue;
 
-        if (fi->extension().lower() != "png" && 
+        if (fi->extension().lower() != "png" &&
             fi->extension().lower() != "jpg" &&
             fi->extension().lower() != "gif" &&
             fi->extension().lower() != "jpeg")
@@ -2245,7 +2268,7 @@
                             QString("Failed to save cached image: %1")
                             .arg(d->themecachedir + filename));
                 }
-             
+
                 delete tmpimage;
             }
         }
@@ -2254,7 +2277,7 @@
     if (caching)
     {
         caching->Close();
-        caching->deleteLater();        
+        caching->deleteLater();
     }
 }
 
@@ -2263,7 +2286,7 @@
 {
     xbase  = d->m_xbase;
     ybase  = d->m_ybase;
-    
+
     width  = d->m_width;
     height = d->m_height;
 }
@@ -2274,7 +2297,7 @@
     hmult = d->m_hmult;
 }
 
-void MythContext::GetScreenSettings(int &width, float &wmult, 
+void MythContext::GetScreenSettings(int &width, float &wmult,
                                     int &height, float &hmult)
 {
     height = d->m_screenheight;
@@ -2284,12 +2307,12 @@
     hmult = d->m_hmult;
 }
 
-void MythContext::GetScreenSettings(int &xbase, int &width, float &wmult, 
+void MythContext::GetScreenSettings(int &xbase, int &width, float &wmult,
                                     int &ybase, int &height, float &hmult)
 {
     xbase  = d->m_screenxbase;
     ybase  = d->m_screenybase;
-    
+
     height = d->m_screenheight;
     width = d->m_screenwidth;
 
@@ -2300,7 +2323,7 @@
 void MythContext::GetResolutionSetting(const QString &type,
                                        int &width, int &height,
                                        double &forced_aspect,
-                                       short &refresh_rate, 
+                                       short &refresh_rate,
                                        int index)
 {
     bool ok = false, ok0 = false, ok1 = false;
@@ -2461,11 +2484,17 @@
     QDir dir(testdir);
     if (dir.exists())
         return testdir;
+    else
+        VERBOSE(VB_IMPORTANT, "No theme dir: " + dir.absPath());
+
 
     testdir = GetThemesParentDir() + themename;
     dir.setPath(testdir);
     if (dir.exists())
         return testdir;
+    else
+        VERBOSE(VB_IMPORTANT, "No theme dir: " + dir.absPath());
+
 
     testdir = GetThemesParentDir() + "G.A.N.T";
     dir.setPath(testdir);
@@ -2476,6 +2505,8 @@
         SaveSetting("Theme", "G.A.N.T");
         return testdir;
     }
+    else
+        VERBOSE(VB_IMPORTANT, "No theme dir: " + dir.absPath());
 
     VERBOSE(VB_IMPORTANT, QString("Could not find theme: %1").arg(themename));
     return "";
@@ -2556,7 +2587,7 @@
     return &d->m_dbmanager;
 }
 
-void MythContext::DBError(const QString &where, const QSqlQuery& query) 
+void MythContext::DBError(const QString &where, const QSqlQuery& query)
 {
     QString str = QString("DB Error (%1):\n").arg(where);
 
@@ -2710,14 +2741,15 @@
     }
     else
     {
-        VERBOSE(VB_IMPORTANT, 
+        VERBOSE(VB_IMPORTANT,
              QString("Database not open while trying to load setting: %1")
                                 .arg(key));
     }
 
     if (!found)
-        value = d->m_settings->GetSetting(key, defaultval); 
+        return d->m_settings->GetSetting(key, defaultval);
 
+    // Store the value (only if we have actually found it in the database)
     if (!value.isNull() && d && d->useSettingsCache)
     {
         d->settingsCacheLock.lock();
@@ -2796,7 +2828,7 @@
     }
     else
     {
-        VERBOSE(VB_IMPORTANT, 
+        VERBOSE(VB_IMPORTANT,
              QString("Database not open while trying to load setting: %1")
                                 .arg(key));
     }
@@ -2837,7 +2869,7 @@
     QColorGroup disabled = pal.disabled();
     QColorGroup inactive = pal.inactive();
 
-    const QString names[] = { "Foreground", "Button", "Light", "Midlight",  
+    const QString names[] = { "Foreground", "Button", "Light", "Midlight",
                               "Dark", "Mid", "Text", "BrightText", "ButtonText",
                               "Base", "Background", "Shadow", "Highlight",
                               "HighlightedText" };
@@ -2893,7 +2925,7 @@
     {
         QString pmapname = d->m_themepathname +
                            d->m_qtThemeSettings->GetSetting("BackgroundPixmap");
- 
+
         bgpixmap = LoadScalePixmap(pmapname);
         if (bgpixmap)
         {
@@ -3061,7 +3093,7 @@
     return ret;
 }
 
-QPixmap *MythContext::LoadScalePixmap(QString filename, bool fromcache) 
+QPixmap *MythContext::LoadScalePixmap(QString filename, bool fromcache)
 {
     if (filename.left(5) == "myth:")
         return NULL;
@@ -3143,7 +3175,7 @@
         QImage tmp2 = tmpimage.smoothScale((int)(tmpimage.width() * wmult),
                                            (int)(tmpimage.height() * hmult));
         ret->convertFromImage(tmp2);
-    }       
+    }
     else
     {
         if (!ret->load(filename))
@@ -3164,7 +3196,7 @@
     QUrl qurl = url;
     if (qurl.host() == "")
         return NULL;
- 
+
     if ((d->imageCache.contains(url)) && (reCache == false))
         return &(d->imageCache[url]);
 
@@ -3184,7 +3216,7 @@
             return &(d->imageCache[url]);
         }
     }
-    
+
     return NULL;
 }
 
@@ -3200,7 +3232,7 @@
  * This allows defining settings for the session only, without touching the
  * settings in the data base.
  */
-void MythContext::OverrideSettingForSession(const QString &key, 
+void MythContext::OverrideSettingForSession(const QString &key,
                                             const QString &value)
 {
     d->overriddenSettings[key] = value;
@@ -3210,7 +3242,7 @@
                                         bool quickTimeout, bool block)
 {
     d->serverSockLock.lock();
-    
+
     if (!d->serverSock)
     {
         ConnectToMasterServer(false);
@@ -3218,7 +3250,7 @@
     }
 
     bool ok = false;
-    
+
     if (d->serverSock)
     {
         d->serverSock->writeStringList(strlist);
@@ -3277,10 +3309,10 @@
                 d->serverSockLock.lock();
             qApp->unlock();
         }
-    }    
+    }
 
     d->serverSockLock.unlock();
-    
+
     return ok;
 }
 
@@ -3331,7 +3363,14 @@
     socket->writeStringList(strlist);
     socket->readStringList(strlist, true);
 
-    if (strlist[0] == "REJECT")
+    if (strlist.empty())
+    {
+        VERBOSE(VB_IMPORTANT, "Protocol version check failure. The response "
+                "to MYTH_PROTO_VERSION was empty.");
+
+        return false;
+    }
+    else if (strlist[0] == "REJECT")
     {
         VERBOSE(VB_GENERAL, QString("Protocol version mismatch (frontend=%1,"
                                     "backend=%2)\n")
@@ -3340,7 +3379,7 @@
         if (d->m_height && d->m_width)
         {
             qApp->lock();
-            MythPopupBox::showOkPopup(d->mainWindow, 
+            MythPopupBox::showOkPopup(d->mainWindow,
                                       "Connection failure",
                                       tr(QString("The server uses network "
                                                  "protocol version %1, "
@@ -3483,7 +3522,7 @@
 
 
     // No current DBSchemaVer? Empty database, so upgrade to create tables
-    if (dbver.isEmpty())
+    if (dbver.isEmpty() || dbver == "0")
     {
         VERBOSE(VB_GENERAL, "No current database version. Auto upgrading");
         return MYTH_SCHEMA_UPGRADE;
